#![cfg_attr(not(debug_assertions), windows_subsystem = "windows")]
//TAURIクレート
use tauri::{State,Manager};
//サウンドモジュール
mod sound;
//サウンド再生コマンド
#[tauri::command]
fn playpiano(
  note: usize,
  snd: State<'_, sound::Sound>,
) {
  snd.play(note);
}
//メイン関数
fn main() {
  //サウンドデータ
  let files = vec![
    String::from("sounds/C3.ogg"), //白鍵
    String::from("sounds/D3.ogg"),
    String::from("sounds/E3.ogg"),
    String::from("sounds/F3.ogg"),
    String::from("sounds/G3.ogg"),
    String::from("sounds/A3.ogg"),
    String::from("sounds/B3.ogg"),
    String::from("sounds/C4.ogg"),
    String::from("sounds/D4.ogg"),
    String::from("sounds/E4.ogg"),
    String::from("sounds/F4.ogg"),
    String::from("sounds/G4.ogg"),
    String::from("sounds/A4.ogg"),
    String::from("sounds/B4.ogg"),
    String::from("sounds/C5.ogg"),
    String::from("sounds/D5.ogg"),
    String::from("sounds/E5.ogg"),
    String::from("sounds/F5.ogg"),
    String::from("sounds/G5.ogg"),
    String::from("sounds/A5.ogg"),
    String::from("sounds/B5.ogg"),
    String::from("sounds/Df3.ogg"), //黒鍵
    String::from("sounds/Ef3.ogg"),
    String::from("sounds/Gf3.ogg"),
    String::from("sounds/Af3.ogg"),
    String::from("sounds/Bf3.ogg"),
    String::from("sounds/Df4.ogg"),
    String::from("sounds/Ef4.ogg"),
    String::from("sounds/Gf4.ogg"),
    String::from("sounds/Af4.ogg"),
    String::from("sounds/Bf4.ogg"),
    String::from("sounds/Df5.ogg"),
    String::from("sounds/Ef5.ogg"),
    String::from("sounds/Gf5.ogg"),
    String::from("sounds/Af5.ogg"),
    String::from("sounds/Bf5.ogg"),
  ];
  //デスクトップアプリのセットアップ
  tauri::Builder::default()
  .setup(|app| {
    let snd = sound::Sound::new(app,files);
    app.manage(snd);
    Ok(())
  })
  .invoke_handler(tauri::generate_handler![playpiano])
  .run(tauri::generate_context!())
  .expect("error while running tauri application");
}
