const { invoke } = window.__TAURI__.tauri;
//ピアノの再生
async function playPiano(index) {
  await invoke("playpiano", { note: index });
}
//DOMが全て読み込み完了した時
window.addEventListener("DOMContentLoaded", () => {
  const piano = document.querySelector('#piano');
  const WHITE_KEY = 7*3;
  //白鍵のタグの追加
  for ( var i = 0; i < WHITE_KEY; i++ ) {
    piano.insertAdjacentHTML(
      'beforeend',
      '<div class="white"><a> </a></div>');
  }
  //黒鍵のタグの追加
  for ( var i = 0; i < WHITE_KEY; i++ ) {
    if ( !((i+4) % 7) || !(i % 7) ) continue;
    let style = '"margin-left:'+(30*i-640)+'px"';
    piano.insertAdjacentHTML(
      'beforeend',
      '<div class="black" style='+style+'><a> </a></div>');
  }
  //白鍵がクリックされた時のイベントリスナー
  let white = document.querySelectorAll('.white a');
  white.forEach(function(a,index) {
    a.addEventListener("click", () => playPiano(index));
  });
  //黒鍵がクリックされた時のイベントリスナー
  let black = document.querySelectorAll('.black a');
  black.forEach(function(a,index) {
    a.addEventListener("click", () => playPiano(WHITE_KEY+index));
  });
});
